io.vertx.core.eventbus

## Interface MessageProducer<T>

- All Superinterfaces:
    StreamBase, WriteStream<T>

      public interface MessageProducer<T>
      extends WriteStream<T>

  Represents a stream of message that can be written to.

  Author:
    Julien Viet

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static int` | `DEFAULT_WRITE_QUEUE_MAX_SIZE`

  - ### Method Summary

    All Methods Instance Methods Abstract Methods
    Modifier and Type | Method and Description
    --- | ---
    `String` | `address()`
    `void` | `close()` Closes the producer, this method should be called when the message producer is not used anymore.
    `MessageProducer<T>` | `deliveryOptions(DeliveryOptions options)` Update the delivery options of this producer.
    `MessageProducer<T>` | `drainHandler(Handler<Void> handler)` Set a drain handler on the stream.
    `void` | `end()` Closes the producer, calls `close()`
    `MessageProducer<T>` | `exceptionHandler(Handler<Throwable> handler)` Set an exception handler on the write stream.
    `MessageProducer<T>` | `send(T message)` Synonym for `write(Object)`.
    `<R> MessageProducer<T>` | `send(T message, Handler<AsyncResult<Message<R>>> replyHandler)`
    `MessageProducer<T>` | `setWriteQueueMaxSize(int maxSize)` Set the maximum size of the write queue to `maxSize`.
    `MessageProducer<T>` | `write(T data)` Write some data to the stream.

    - ### Methods inherited from interface io.vertx.core.streams.WriteStream

      `end, writeQueueFull`

- - ### Field Detail

    - #### DEFAULT_WRITE_QUEUE_MAX_SIZE

          static final int DEFAULT_WRITE_QUEUE_MAX_SIZE

      See Also:
        Constant Field Values

  - ### Method Detail

    - #### send

          MessageProducer<T> send(T message)

      Synonym for `write(Object)`.
      Parameters:
        `message` - the message to send
      Returns:
        reference to this for fluency

    - #### send

          <R> MessageProducer<T> send(T message,
                                      Handler<AsyncResult<Message<R>>> replyHandler)

    - #### exceptionHandler

          MessageProducer<T> exceptionHandler(Handler<Throwable> handler)

      Description copied from interface: `WriteStream`
      Set an exception handler on the write stream.
      Specified by:
        `exceptionHandler` in interface `StreamBase`
      Specified by:
        `exceptionHandler` in interface `WriteStream<T>`
      Parameters:
        `handler` - the exception handler
      Returns:
        a reference to this, so the API can be used fluently

    - #### write

          MessageProducer<T> write(T data)

      Description copied from interface: `WriteStream`
      Write some data to the stream. The data is put on an internal write queue, and the write actually happens asynchronously. To avoid running out of memory by putting too much on the write queue, check the `WriteStream.writeQueueFull()` method before writing. This is done automatically if using a `Pump`.
      Specified by:
        `write` in interface `WriteStream<T>`
      Parameters:
        `data` - the data to write
      Returns:
        a reference to this, so the API can be used fluently

    - #### setWriteQueueMaxSize

          MessageProducer<T> setWriteQueueMaxSize(int maxSize)

      Description copied from interface: `WriteStream`
      Set the maximum size of the write queue to `maxSize`. You will still be able to write to the stream even if there is more than `maxSize` items in the write queue. This is used as an indicator by classes such as `Pump` to provide flow control.

      The value is defined by the implementation of the stream, e.g in bytes for a `NetSocket`, the number of `Message` for a `MessageProducer`, etc...
      Specified by:
        `setWriteQueueMaxSize` in interface `WriteStream<T>`
      Parameters:
        `maxSize` - the max size of the write stream
      Returns:
        a reference to this, so the API can be used fluently

    - #### drainHandler

          MessageProducer<T> drainHandler(Handler<Void> handler)

      Description copied from interface: `WriteStream`
      Set a drain handler on the stream. If the write queue is full, then the handler will be called when the write queue is ready to accept buffers again. See `Pump` for an example of this being used.

      The stream implementation defines when the drain handler, for example it could be when the queue size has been reduced to `maxSize / 2`.
      Specified by:
        `drainHandler` in interface `WriteStream<T>`
      Parameters:
        `handler` - the handler
      Returns:
        a reference to this, so the API can be used fluently

    - #### deliveryOptions

          MessageProducer<T> deliveryOptions(DeliveryOptions options)

      Update the delivery options of this producer.
      Parameters:
        `options` - the new options
      Returns:
        this producer object

    - #### address

          String address()

      Returns:
        The address to which the producer produces messages.

    - #### end

          void end()

      Closes the producer, calls `close()`
      Specified by:
        `end` in interface `WriteStream<T>`

    - #### close

          void close()

      Closes the producer, this method should be called when the message producer is not used anymore.

Copyright © 2016. All rights reserved.